{########################################
 #                                      #
 # Practica 2: Alejandro Dobeson Beirao #
 #   G49       Juan Carreras Huertas    #
 #                                      #
 ########################################}


PROGRAM Calendario;

(* Dado un annio un mes y un dia de ese mes, este programa calcula el dia de
   la semana correspondiente, sabiendo que el dia 1 de Enero de 1900 fue
   lunes. El programa solo es valido para dias posteriores al 1 de Enero
   de 1990 *)

USES
  Crt;


VAR
  AnyoG,
  MesG,
  DiaG:                  (* Dia, mes y annio del dia a calcular *)
    Integer;
  opcion:               (* Opcion introducida en el menu *)
    integer;
  domingoG:              (* Fecha correspondiente al primer domingo del anyo *)
    integer;
  Transcurridos:        (* Dias transcurridos desde el 1/1/1900 *)
    LongInt;

(*************************************************************************)

PROCEDURE Menu (var aux:Integer);

  (* Muestra el menu, y recoge la opcion elegida *)

BEGIN (* Menu *)
  REPEAT
    BEGIN
      writeln;
      writeln('1. Consultar correspondencia fecha / dia de la semana');
      writeln('2. Consultar el primer domingo de un anyo');
      writeln('3. Consultar el semanario de un anyo');
      writeln('4. Consultar el calendario de un mes');
      writeln('5. Consultar el calendario de un anyo');
      writeln;
      writeln('0. Salir');
      writeln;
      writeln('Haz tu eleccion');
      readln(aux);
      writeln;
      IF (aux < 0 ) and ( aux > 5) THEN
        BEGIN
        writeln('Error: Eleccion incorrecta.');
        END
    End
  UNTIL ( aux >= 0 ) and ( aux < 6 );
END; (* Menu *)

(*************************************************************************)

FUNCTION EsBisiesto ( Anyo: Integer ): Boolean;

  (* Determina si Anyo es bisiesto. Un annio es bisiesto si se cumplen una
     de las dos siguientes condiciones
     - Es multiplo de cuatro y no es multiplo de cien
     - Es multiplo de 400. *)

BEGIN  (* EsBisiesto *)
  EsBisiesto := ((Anyo Mod 4 = 0) AND (Anyo Mod 100 <> 0))
                OR (Anyo Mod 400 = 0);
END;  (* EsBisiesto *)

(*************************************************************************)


FUNCTION DiasMes ( Anyo, Mes: Integer ): Integer;

  (* Devuelve el n?mero de dias de Mes. Los meses se identifican por su
     n?mero de orden *)

BEGIN  (* DiasMes *)
  CASE Mes OF
    1, 3, 5, 7, 8, 10, 12: DiasMes := 31;
    2: IF EsBisiesto(Anyo) THEN
         DiasMes := 29
       ELSE
         DiasMes := 28;
    4, 6, 9, 11: DiasMes := 30;
  END;  (* CASE *)
END;  (* DiasMes *)

(*************************************************************************)

PROCEDURE LeerMes (var aux: integer);

  (* Lee el mes y comprueba su validez *)

Begin
  REPEAT
    write('Escribe mes: ');
    readln(aux);
    writeln;
    IF (aux < 1) OR (aux > 12) THEN
      Begin
        writeln('Mes Incorrecto');
        writeln;
      End;
  UNTIL (aux > 0) AND (aux < 13)
End;

(*************************************************************************)


PROCEDURE LeerAnyo (var aux: integer);

   (* Lee el anyo y comprueba su validez *)

begin
  write('Introduzca el anyo: ');
  REPEAT
  readln(aux);
  writeln;
  IF (aux < 1900) THEN
    begin
      writeln('Anyo incorrecto. Introduzca un anyo igual o posterior a 1900');
      writeln;
    end
  UNTIL (aux >= 1900);
end;

(*************************************************************************)

PROCEDURE LeerFecha (VAR Anyo, Mes, Dia: Integer);

  (* Lee una fecha: dia, mes y annio *)

  (******************************************************************)

  FUNCTION VerificaFecha (Anyo, Mes, Dia: Integer): boolean;

    (* Comprueba los fallos al introducir la fecha del tipo 31 de Abril,
       29 de Febrero si no es bisiesto... *)

  BEGIN (* VerificaFecha *)

  IF (DiasMes(Anyo, Mes) < Dia) THEN
    Begin
      VerificaFecha := FALSE;
      writeln;
      writeln('El dia que has especificado no tuvo lugar. Por favor, comprueba');
      writeln('que la fecha sea correcta, o si te has equivocado al escribirla ');
      writeln;
    End
  ELSE
    VerificaFecha := TRUE;
  END; (* VerificaFecha*)

  (******************************************************************)

BEGIN (* LeerFecha *)
  REPEAT
    REPEAT
      Write('Introduzca el dia: ');
      ReadLn(Dia);
      IF (Dia < 1) OR (Dia > 31) THEN
        begin
          Writeln;
          Writeln('Dia incorrecto');
        end
    UNTIL (Dia > 0) AND (Dia < 32);
    LeerMes(mes);
    LeerAnyo(anyo);
  UNTIL (VerificaFecha(anyo, mes, dia) = TRUE);
END; (* LeerFecha *)

(*************************************************************************)

PROCEDURE EscribeDia ( Dia:
                         Integer );
  (* Recibe un entero que representa a un dia de la semana y escribe
     el nombre del dia correspondiente. El 0 es lunes, el 1 martes, ...*)

BEGIN  (* EscribeDia *)
  CASE Dia OF
    0 : WriteLn('Lunes');
    1 : WriteLn('Martes');
    2 : WriteLn('Miercoles');
    3 : WriteLn('Jueves');
    4 : WriteLn('Viernes');
    5 : WriteLn('Sabado');
    6 : WriteLn('Domingo');
  END;  (* CASE *)
END;  (* EscribeDia *)

  (*****************************)

Function EscribeMes (mes: integer): string;

  (* Identifica el numero de mes con su nombre, y lo escribe *)

BEGIN
  CASE mes OF
    1: write('Enero');
    2: write('Febrero');
    3: write('Marzo');
    4: write('Abril');
    5: write('Mayo');
    6: write('Junio');
    7: write('Julio');
    8: write('Agosto');
    9: write('Septiembre');
    10: write('Octubre');
    11: write('Noviembre');
    12: write('Diciembre');
  END; (* CASE *)
END;

(*************************************************************************)

PROCEDURE PrimerDomingo ( primerdia: longint; var dom: integer);

   (* Determina el primer domingo del anyo introducido, y lo muestra *)

BEGIN
  CASE (primerdia mod 7) OF
    0 : dom := 7;
    1 : dom := 6;
    2 : dom := 5;
    3 : dom := 4;
    4 : dom := 3;
    5 : dom := 2;
    6 : dom := 1;
  END;
END;

(*************************************************************************)

PROCEDURE EscribeSemanario (dom: integer; var anyo: integer);

  (* Escribe todos los domingos de un anyo *)

VAR
  mes: integer;

BEGIN
  mes := 1;
  writeln('Semanas de ', Anyo, ':');
  REPEAT
    writeln(dom,', ', EscribeMes(mes));
    dom := dom + 7;
    IF (dom > DiasMes(anyo, mes)) THEN
      Begin
        dom := (dom - DiasMes(anyo, mes));
        mes := mes + 1;
        writeln;
        IF (mes < 13) THEN
          Begin
            writeln('Pulsa INTRO para pasar al siguiente mes');
          End;
        IF (mes = 13) THEN
          Begin
            writeln('Pulsa INTRO para volver al menu');
          End;
        readln;
      End
  UNTIL (mes = 13);
END;

(*************************************************************************)


PROCEDURE EscribeCalendarioMes (dia: longint; mes, anyo: integer);

  (* Escribe el calendario correspondiente a un mes *)

var

aux, contador: integer;

Begin
  writeln(' L  M  X  J  V  S  D');
  writeln;
  aux := 1;
  CASE (dia mod 7) OF
    0: Begin
         write(' ');
         contador := 0;
         REPEAT
           write(aux);
           contador := contador + 1;
           aux := aux + 1;
           IF (aux < 10) THEN
             Begin
               write('  ');
             End
           ELSE
             Begin
               write(' ');
             End;
           IF (contador = 7) THEN
             Begin
               contador := 0;
               writeln;
               IF (aux < 10) THEN
                 Begin
                   write(' ');
                 End;
             End;
         UNTIL (aux > DiasMes(anyo, mes));
       End;
    1: Begin
         write('    ');
         contador := 1;
         REPEAT
           write(aux);
           contador := contador + 1;
           aux := aux + 1;
           IF (aux < 10) THEN
             Begin
               write('  ');
             End
           ELSE
             Begin
               write(' ');
             End;
           IF (contador = 7) THEN
             Begin
               contador := 0;
               writeln;
               IF (aux < 10) THEN
                 Begin
                   write(' ');
                 End;
             End;
         UNTIL (aux > DiasMes(anyo, mes));
       End;
    2: Begin
         write('       ');
         contador := 2;
         REPEAT
           write(aux);
           contador := contador + 1;
           aux := aux + 1;
           IF (aux < 10) THEN
             Begin
               write('  ');
             End
           ELSE
             Begin
               write(' ');
             End;
           IF (contador = 7) THEN
             Begin
               contador := 0;
               writeln;
               IF (aux < 10) THEN
                 Begin
                   write(' ');
                 End;
             End;
         UNTIL (aux > DiasMes(anyo, mes));
       End;
    3: Begin
         write('          ');
         contador := 3;
         REPEAT
           write(aux);
           contador := contador + 1;
           aux := aux + 1;
           IF (aux < 10) THEN
             Begin
               write('  ');
             End
           ELSE
             Begin
               write(' ');
             End;
           IF (contador = 7) THEN
             Begin
               contador := 0;
               writeln;
               IF (aux < 10) THEN
                 Begin
                   write(' ');
                 End;
             End;
         UNTIL (aux > DiasMes(anyo, mes));
       End;
    4: Begin
         write('             ');
         contador := 4;
         REPEAT
           write(aux);
           contador := contador + 1;
           aux := aux + 1;
           IF (aux < 10) THEN
             Begin
               write('  ');
             End
           ELSE
             Begin
               write(' ');
             End;
           IF (contador = 7) THEN
             Begin
               contador := 0;
               writeln;
               IF (aux < 10) THEN
                 Begin
                   write(' ');
                 End;
             End;
         UNTIL (aux > DiasMes(anyo, mes));
       End;
    5: Begin
         write('                ');
         contador := 5;
         REPEAT
           write(aux);
           contador := contador + 1;
           aux := aux + 1;
           IF (aux < 10) THEN
             Begin
               write('  ');
             End
           ELSE
             Begin
               write(' ');
             End;
           IF (contador = 7) THEN
             Begin
               contador := 0;
               writeln;
               IF (aux < 10) THEN
                 Begin
                   write(' ');
                 End;
             End;
         UNTIL (aux > DiasMes(anyo, mes));
       End;
    6: Begin
         write('                   ');
         contador := 6;
         REPEAT
           write(aux);
           contador := contador + 1;
           aux := aux + 1;
           IF (aux < 10) THEN
             Begin
               write('  ');
             End
           ELSE
             Begin
               write(' ');
             End;
           IF (contador = 7) THEN
             Begin
               contador := 0;
               writeln;
               IF (aux < 10) THEN
                 Begin
                   write(' ');
                 End;
             End;
         UNTIL (aux > DiasMes(anyo, mes));
       End;
    End;
  writeln;
End;

(*************************************************************************)

FUNCTION DiasTranscurridos (Anyo, Mes, Dia: Integer): LongInt;

  (* Calcula el numero de dias que han transcurrido desde el 1 de Enero
     de 1900 hasta la fecha Dia/Mes/Anyo *)

  (******************************************************************)

  FUNCTION DiasAnyosCompletos (Anyo: Integer): LongInt;

    (* Calcula el numero de dias que han transcurrido desde el 1 de Enero
      de 1900 hasta el 1 de Enero de Anyo *)

    (*******************************************************************)

    FUNCTION ContarAnyosBisiestos( AnyoInicio, AnyoFinal: Integer): Integer;
         (* Calcula el nmero de aos bisiestos existentes entre
         AnyoInicio y AnyoFinal, ambos inclusive *)
    VAR
      Contador, NumeroAnyos: Integer;

    BEGIN  (* ContarAnyosBisiestos *)
      NumeroAnyos := 0;
      FOR Contador := AnyoInicio TO AnyoFinal DO
        IF EsBisiesto(Contador)
          THEN
            NumeroAnyos := NumeroAnyos + 1;
      ContarAnyosBisiestos := NumeroAnyos;
    END;  (* ContarAnyosBisiestos *)

    (************************************************************)

  VAR
    AnyosTranscurridos,
    AnyosBisiestos:
      LongInt;


  BEGIN (* DiasAnyosCompletos *)

    AnyosTranscurridos := Anyo - 1900;
    IF AnyosTranscurridos > 0
      THEN
        AnyosBisiestos := ContarAnyosBisiestos(1900, Anyo - 1)
      ELSE
        AnyosBisiestos := 0;
    DiasAnyosCompletos := AnyosBisiestos * 366 +
                          (AnyosTranscurridos - AnyosBisiestos) * 365;

  END; (* DiasAnyosCompletos *)

  (*****************************************************************)

  FUNCTION DiasEsteAnyo ( Anyo,
                          Mes,
                          Dia:
                            Integer ):
                              Integer;

    (* Calcula los dias transcurridos desde el 1/Enero/Anyo hasta
      Dia/Mes/Anyo. Por supuesto Dia todavia no ha transcurrido *)

  VAR
    I,
    DiasAux:
      Integer;

  BEGIN  (* DiasEsteAnyo *)
    DiasAux := 0;
    FOR I := 1 TO (Mes - 1) DO
      DiasAux := DiasAux + DiasMes(Anyo, I);
    DiasEsteAnyo := DiasAux + Dia - 1;
  END;  (* DiasEsteAnyo *)

  (****************************************************************)

BEGIN  (* DiasTranscurridos *)

  DiasTranscurridos := DiasAnyosCompletos(Anyo) +
                       DiasEsteAnyo(Anyo, Mes, Dia);

END;  (* DiasTranscurridos *)

(*************************************************************************)

FUNCTION DiaSemana ( NumeroDias:
                       LongInt ):
                         Integer;

  (* Sabiendo que el 1/1/1990 era lunes, esta funcion calcula qu da
     de la semana es despues de haber transcurrido NumeroDias *)

BEGIN  (* DiaSemana *)
  DiaSemana := NumeroDias mod 7;
END;  (* DiaSemana *)

(*************************************************************************)

Procedure CalendarioCompleto;

var
  anyo, mes: integer;
  trans: longint;

begin
  LeerAnyo(Anyo);
  for mes := 1 to 12 do
  begin
    Trans := DiasTranscurridos(Anyo, Mes, 1);
    writeln;
    writeln('     ', EscribeMes(mes));
    writeln;
    EscribeCalendarioMes(Trans, mes, anyo);
    writeln;
    writeln('Pulsa INTRO para continuar...');
    readln;
  end
end;

(*************************************************************************)

BEGIN  (* Calendario *)
  clrscr;
  writeln('#################################################');
  writeln;
  writeln('                   Calendario');
  writeln;
  writeln('#################################################');
  REPEAT
    Menu(opcion);
    CASE opcion OF
     1: Begin
          LeerFecha(AnyoG, MesG, DiaG);
          EscribeDia(DiaSemana(DiasTranscurridos(AnyoG, MesG, DiaG)));
        End;
     2: Begin
          LeerAnyo(AnyoG);
          Transcurridos := (DiasTranscurridos(AnyoG, 1, 1));
          PrimerDomingo(Transcurridos, domingoG);
          writeln('El primer domingo del anyo ', AnyoG, ' fue ', DomingoG, ' Enero')
        End;
     3: Begin
          LeerAnyo(AnyoG);
          Transcurridos := (DiasTranscurridos(AnyoG, 1, 1));
          PrimerDomingo(Transcurridos, domingoG);
          EscribeSemanario(domingoG, anyoG);
        End;
     4: Begin
          LeerMes(MesG);
          LeerAnyo(AnyoG);
          Transcurridos := DiasTranscurridos(AnyoG, MesG, 1);
          EscribeCalendarioMes(Transcurridos, mesG, anyoG);
        End;
     5: Begin
          CalendarioCompleto;
        End;
    END;
  UNTIL (opcion = 0)
END.  (* Calendario *)